var map;
var mgr;
var map_canvas;
var sidebar;
var sidebar_content;

var maplok = {
	groups: [],
	watchObject: {gid: -1, oid: -1},
	init: function() {
		if (GBrowserIsCompatible()) {
			map_canvas = document.getElementById("map_canvas");
			sidebar = document.getElementById("sidebar");
			sidebar_content = document.getElementById("sidebar_content");
			document.getElementById("sidebar_header_group_checkbox").checked = false;

			var height=document.documentElement.clientHeight;
			var width=document.documentElement.clientWidth;
			map_canvas.style.height = height + "px";
			map_canvas.style.width = (width - 250) + "px";
			sidebar.style.height = height + "px";

			map = new GMap2(map_canvas);
			map.setCenter(new GLatLng(49.930008,15.369873), 7);
			map.setMapType(G_NORMAL_MAP);
			map.setUIToDefault();
			
			map.addControl(new GOverviewMapControl());
			
			mgr = new MarkerManager(map, {trackMarkers: true });

			if (window.attachEvent) {
				window.attachEvent("onresize", maplok.resize);
			} else {
				window.addEventListener("resize", maplok.resize, false);
			}
			maplok.downloadGroups();
		}
	},
	destroy: function() {
		GUnload();
		maplok.groups = [];
	},
	resize: function() {
		var height=document.documentElement.clientHeight;
		var width=document.documentElement.clientWidth;

		map_canvas.style.height = height + "px";
		map_canvas.style.width = (width - 250) + "px";
		sidebar.style.height = height + "px";

		map.checkResize();
		map.setCenter(map.getCenter());
	},
	downloadGroups: function() {
		GDownloadUrl("/api/group/", function(data) {
			var maplok = window.maplok;
			data = eval('(' + data + ')');
			maplok.processGroups(data);
		});
	},
	processGroups: function(data) {
		maplok.groups = [];
		for(var i=0; i < data.length; i++) {
			var item = data[i];
			var group = {name: item.name, picture: item.picture, objects: []};
			
			group.sidebar = maplok.createSidebarItem(i, item.name);
			maplok.groups.push(group);
		}
		document.getElementById("sidebar_header_group").appendChild(document.createTextNode(maplok.groups.length + " skupin"));
	},
	downloadObjects: function(update) {
		var param = '';
		
		for(var i=0; i < maplok.groups.length; i++) {
			if (maplok.groups[i].sidebar.input.checked) {
				param = param + 'name=' + Url.encode(maplok.groups[i].name) + '&';
			}
		}
		
		if (param == '')
			return;
		
		GDownloadUrl("/api/group/?" + param, function(data) {
			var maplok = window.maplok;
			data = eval('(' + data + ')');
			
			maplok.processObjects(data);
			
			window.setTimeout(function() {
				maplok.downloadObjects(true);
			}, 5000);
		});
	},
	processObjects: function(data) {
		for(var i=0; i < data.length; i++) {
			var dataItem = data[i];
			var id = maplok.getGroupIdByName(dataItem.name);
			
			for(var y=0; y < dataItem.objects.length; y++) {
			  var item = dataItem.objects[y];
			  if(maplok.groups[id].objects.length > y) {
			  	var o = maplok.groups[id].objects[y];
			  	
			  	if (item.available == "true") {
			  		o.point = new GLatLng(item.lat, item.lng);
						if (o.marker == null) {
							o.marker = new GMarker(o.point, {title: dataItem.name, icon: maplok.customIcon(dataItem.icon)});
							var clickFn = (function() { //reseni na joining closures
								var oid = y;
								var gid = id;
								return function() { maplok.showDialog(gid, oid); }
							})();
							o.event = GEvent.addListener(o.marker, "click", clickFn);
							mgr.addMarker(o.marker, 3);
						}
						o.marker.setLatLng(o.point);
					} else {
						if (o.marker != null) {
							GEvent.removeListener(o.event);
							mgr.removeMarker(o.marker);
							o.marker = null;
						}
					}
					maplok.groups[id].objects[y] = o;
			  } else {
					var o = {marker: null};
					
					if (item.available == "true") {						
						o.point = new GLatLng(item.lat, item.lng);
						o.marker = new GMarker(o.point, {title: dataItem.name, icon: maplok.customIcon(dataItem.icon)});
							var clickFn = (function() { //reseni na joining closures
							var oid = y;
							var gid = id;
							return function() { maplok.showDialog(gid, oid); }
						})();
						o.event = GEvent.addListener(o.marker, "click", clickFn);
		
						mgr.addMarker(o.marker, 3);
					}
					maplok.groups[id].objects.push(o);
				}
			}
		}
		if (maplok.watchObject.gid != -1 && maplok.watchObject.oid != -1) {
			if (maplok.groups[maplok.watchObject.gid].objects[maplok.watchObject.oid].marker != null) {
				map.setCenter(maplok.groups[maplok.watchObject.gid].objects[maplok.watchObject.oid].marker.getLatLng());
			} else {
				maplok.watchObject.gid = -1;
				maplok.watchObject.oid = -1;
			}
		}
	},
	getGroupIdByName: function(name) {
		for(var i = 0; i < maplok.groups.length; i++)
			if (maplok.groups[i].name == name)
				return i;
		return -1;
	},
	createSidebarItem: function(id, name) {
		var input = document.createElement("input");
		input.type = "checkbox";
		input.event = GEvent.addDomListener(input, "click", function() {
			maplok.setVisible(id, input.checked);
		});
		input.checked = false;
		input.name = "list";

		var label = document.createElement("label");
		label.appendChild(input);
		label.appendChild(document.createTextNode(name));
		
		var zoomA = document.createElement("a");
		zoomA.href = "javascript:void(0)";
		zoomA.appendChild(document.createTextNode('[Přiblížit]'));
		zoomA.event = GEvent.addDomListener(zoomA, "click", function() {
			//maplok.setVisible(id, true);
			maplok.zoomToGroup(id);
		});

		var div = document.createElement("div");
		div.setAttribute("class", "item");
		div.setAttribute("className", "item");
		div.appendChild(label);
		div.appendChild(document.createTextNode(' '));
		div.appendChild(zoomA);

		sidebar_content.appendChild(div);
		return {"input": input};
	},
	setVisible: function(id, checked) {
		maplok.groups[id].sidebar.input.checked = checked;
		if (checked) {
			var checkAll = true;
			for(var i=0; i < maplok.groups.length; i++) {
					if (!maplok.groups[i].sidebar.input.checked) {
						checkAll = false;
						break;
					}
			}
			if (checkAll) {
				document.getElementById("sidebar_header_group_checkbox").checked = true;
			}
			maplok.downloadObjects(false);
			//for(var i = 0; i < maplok.groups[id].objects.length; i++)
			//	maplok.groups[id].objects[i].marker.show();
		} else {
			for(var i = 0; i < maplok.groups[id].objects.length; i++) {
				if (maplok.groups[id].objects[i].marker != null) {
					GEvent.removeListener(maplok.groups[id].objects[i].event);
					mgr.removeMarker(maplok.groups[id].objects[i].marker);
				}
			}
			maplok.groups[id].objects = [];
			if (maplok.watchObject.gid == id) {
				maplok.watchObject.gid = -1;
				maplok.watchObject.oid = -1;
			}

			var uncheckAll = false;
			for(var i=0; i < maplok.groups.length; i++) {
					if (!maplok.groups[i].sidebar.input.checked) {
						uncheckAll = true;
						break;
					}
			}
			if (uncheckAll) {
				document.getElementById("sidebar_header_group_checkbox").checked = false;
			}
		}
	},
	viewAll: function(checked) {
		document.getElementById("sidebar_header_group_checkbox").checked = checked;
		for(var i=0; i < maplok.groups.length; i++) {
			maplok.groups[i].sidebar.input.checked = checked;
			if (checked) {
				//for(var y = 0; y < maplok.groups[i].objects.length; y++)
				//	maplok.groups[i].objects[y].marker.show();
			} else {
				for(var y = 0; y < maplok.groups[i].objects.length; y++) {
					if (maplok.groups[i].objects[y].marker != null) {
						GEvent.removeListener(maplok.groups[i].objects[y].event);
						mgr.removeMarker(maplok.groups[i].objects[y].marker);
					}
				}
				maplok.groups[i].objects = [];
				maplok.watchObject.gid = -1;
				maplok.watchObject.oid = -1;
			}
		}
		if (checked)
			maplok.downloadObjects(false);
	},
	zoomToGroup: function(gid) {
		var bounds = new GLatLngBounds();
		
		var group = maplok.groups[gid];
		if (group.objects.length == 0)
			return;
		
		for(var i = 0; i < group.objects.length; i++) {
			if (group.objects[i].marker != null)
					bounds.extend(group.objects[i].point);
		}
		map.setCenter(bounds.getCenter(), map.getBoundsZoomLevel(bounds));
	},
	setWatchObject: function(gid, oid, state) {
		state = state || false;
		
		if (state) {
			maplok.watchObject.gid = gid;
			maplok.watchObject.oid = oid;
		} else {
			maplok.watchObject.gid = -1;
			maplok.watchObject.oid = -1;
		}
	},
	showDialog: function(gid, oid) {
		var html = "<strong>" + maplok.groups[gid].name + "</strong><br />";
		html+= "<label><input type=\"checkbox\" onclick=\"maplok.setWatchObject(" + gid + "," + oid + ",this.checked)\"";
		
		if (maplok.watchObject.gid == gid && maplok.watchObject.oid == oid)
			html+=" checked";
			
		html+= ">Sledovat tento objekt</label>";
		
		if (map.getZoom() < 9) map.setZoom(9);
		map.panTo(maplok.groups[gid].objects[oid].marker.getLatLng());
		map.openInfoWindowHtml(maplok.groups[gid].objects[oid].marker.getLatLng(), html);
	},
	customIcon: function(url) {
		url = url || false;
		if (!url)
			return G_DEFAULT_ICON;
			
		var icon = new GIcon();
		icon.image = url;
		icon.iconSize = new GSize(33, 33);
		icon.iconAnchor = new GPoint(15, 15);
		icon.infoWindowAnchor = new GPoint(15, 15);
		return icon;
	}	
};