package cz.zcu.kiv.aswi.svk.lokatory.nmealocator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.osgi.service.component.ComponentContext;

import cz.zcu.kiv.aswi.maploc.locator.Locator;


public final class NMEALocator implements Locator{
	private List<GeoPoint> locations = new ArrayList<GeoPoint>();
	private List<Loader> loaders = new ArrayList<Loader>();
	private List<Map<String, Object>> objectsParameters = new ArrayList<Map<String, Object>>();
	private int count = 0;

	protected void activate(ComponentContext context)
    {
        // TODO: Do something on activation
    }

    protected void deactivate(ComponentContext context)
    {
        // TODO: Do something on deactivation
    }


	@Override
	public long addObject(Map<String, Object> parameters) {
		locations.add(count, null);
		objectsParameters.add(count, new HashMap<String, Object>(parameters));

		Loader loader = new Loader(locations, parameters, count);
		loader.start();

		loaders.add(count, loader);

		count++;

		return count-1;
	}


	@Override
	public boolean deleteObject(long id) {
		loaders.get((int) id).interrupt();
		loaders.set((int) id, null);

		locations.set((int) id, null);
		return true;
	}

	@Override
	public String getIdentificator() {
		return this.getClass().getName();
	}

	@Override
	public double[] getLocation(long id) {
		if (locations.get((int) id) == null)
			return new double[] {0, 0};
		return locations.get((int) id).getLocation();
	}

	@Override
	public Map<String, Object> getObjectStatus(long id) {
		Map<String, Object> status =  objectsParameters.get((int) id);
		status.put("available", Boolean.toString(locations.get((int) id) != null));
		return status;
	}

	@Override
	public Set<String> getParamNames() {
		Set<String> paramNames =  new HashSet<String>();
		paramNames.add("file");
		paramNames.add("begin");
		paramNames.add("end");
		return paramNames;
	}


}
