package cz.zcu.kiv.aswi.svk.rejstrik;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.osgi.service.component.ComponentContext;

import cz.zcu.kiv.aswi.maploc.locator.Locator;
import cz.zcu.kiv.aswi.maploc.register.MapPoiGroup;
import cz.zcu.kiv.aswi.maploc.register.Register;
import cz.zcu.kiv.aswi.svk.rejstrik.konfigurace.Konfigurace;

public class Rejstrik implements Register {
	private List<Locator> locators;
	private List<PoiGroup> groups;

	public Rejstrik() {
		locators = new ArrayList<Locator>();
		groups = new ArrayList<PoiGroup>();
	}

	protected void activate(ComponentContext context)
    {
        // TODO: Do something on activation
    }

    protected void deactivate(ComponentContext context)
    {
        // TODO: Do something on deactivation
    }

	@Override
	public Iterator<MapPoiGroup> getGroupsOfPoi() {
		return (Iterator<MapPoiGroup>) ((Object) groups.iterator());
	}

	public synchronized void addLocator(Locator l) {
		locators.add(l);
		reloadConfiguration();
	}

	protected synchronized void removeLocator(Locator l) {
		locators.remove(l);
		reloadConfiguration();
	}

	private synchronized void reloadConfiguration() {
		System.out.println("Zacinam odregistrovavat objekty.");
		for (PoiGroup group : groups) {
			for (PoiObject object : group.getObjects()) {
				object.unregister();
			}
		}
		System.out.println("Odregistrace objektu hotova.");


		System.out.println("Nacitam konfiguraci");
		groups = Konfigurace.nacti();
		System.out.println("Konfigurace nactena.");


		System.out.println("Zacinam registrovat objekty.");
		int i = 0;
		for (PoiGroup group : groups) {
			for (PoiObject object : group.getObjects()) {
				object.register(locators);
				if (i % 50 == 0)
					System.out.print("  " + i);
				i++;
			}
		}
		System.out.println();
		System.out.println("Registrace objektu hotova.");

	}
}
