package cz.zcu.kiv.aswi.svk.webui;

import java.io.BufferedReader;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class RestServlet extends HttpServlet {
	private static final long serialVersionUID = 7679840895295353407L;

	@Override
	public void init(ServletConfig config) throws ServletException {

	}

	@Override
	protected void service(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			req.setCharacterEncoding("UTF-8");
			String path = req.getPathInfo();
			if (path == null || path.length() < 2) {
				resp.sendError(403);
				return;
			}
			String[] pathParts = path.split("/");

			String methodName = pathParts[1];

			JSONObject in = new JSONObject();

			if (!req.getMethod().equalsIgnoreCase("GET")) {

				BufferedReader br = req.getReader();

				StringBuffer sb = new StringBuffer();
				char buf[] = new char[4 * 1024];
				int length;

				while((length = br.read(buf)) > 0) {
					sb.append(buf, 0, length);
				}

				in = new JSONObject(sb.toString());
			}

			for (Enumeration<String> en = req.getParameterNames(); en.hasMoreElements();) {
				String key = en.nextElement();
				if (req.getParameterValues(key).length > 1) {
					in.put(key, new JSONArray(req.getParameterValues(key)));
				} else {
					in.put(key, req.getParameter(key));
				}
			}

			if (pathParts.length > 2) {
				in.put("id", Integer.parseInt(pathParts[2], 10));
			}

			methodName = ((req.getMethod().equalsIgnoreCase("GET")) ? "get" : "set") + Character.toUpperCase(methodName.charAt(0)) + methodName.substring(1);

			Method m;
			m = getClass().getDeclaredMethod(methodName, new Class[]{ JSONObject.class});
			Object out = m.invoke(this, in);
			resp.setCharacterEncoding("UTF-8");

			//TODO prehodit na text/json
			resp.setContentType("text/plain;charset=UTF-8");
			resp.setHeader("Expires", "Fri, 30 Oct 1998 14:19:41 GMT");
			resp.setHeader("Cache-Control", "no-cache, must-revalidate");
			resp.getWriter().print(out.toString());

		} catch (SecurityException e) {
			resp.sendError(403, e.getMessage());
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			resp.sendError(404, e.getMessage());
			e.printStackTrace();
		} catch (JSONException e) {
			resp.sendError(500, e.getMessage());
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			resp.sendError(400, e.getMessage());
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			resp.sendError(403, e.getMessage());
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			resp.sendError(503, e.getMessage());
			e.printStackTrace();
		} catch (Exception e) {
			resp.sendError(500, e.getMessage());
		}
	}
}
