package cz.zcu.kiv.aswi.svk.webui;

import java.util.Hashtable;

import javax.servlet.ServletException;

import org.mortbay.servlet.WelcomeFilter;
import org.ops4j.pax.web.service.WebContainer;
import org.osgi.service.component.ComponentContext;
import org.osgi.service.http.HttpContext;
import org.osgi.service.http.NamespaceException;

import cz.zcu.kiv.aswi.maploc.register.Register;

/**
 * Activator pro vizualni cast
 * @author msloup
 *
 */
public final class Server {
	private Register register;
    private WebContainer webContainer;
    private boolean serverStarted;

    protected void activate(ComponentContext context)
    {
        // TODO: Do something on activation
    }

    protected void deactivate(ComponentContext context)
    {
        // TODO: Do something on deactivation
    }

    protected synchronized void setRegister(Register r) {
    	register = r;

    	if (webContainer != null)
    		startServer();
    }

    protected synchronized void unsetRegister(Register r) {
    	if (serverStarted)
    		stopServer();
    	register = null;
    }

    protected synchronized void setWebContainer(WebContainer wc) {
    	webContainer = wc;

    	if (register != null)
    		startServer();
    }

    protected synchronized void unsetWebContainer(WebContainer wc) {
    	if (serverStarted)
    		stopServer();
    	webContainer = null;
    }

    private synchronized void startServer() {
    	if (serverStarted)
    		stopServer();

    	try {
    		final HttpContext httpContext = webContainer.createDefaultHttpContext();

	        //zaregistrovani servletu, co se stara o REST API uzivatelskeho prostredi
	        webContainer.registerServlet("/api", new WebUiApi(register), new Hashtable<String, String>(), httpContext);

        	//zaregistrovani html stranek a ostatnich souboru
        	webContainer.registerResources("/", "/resources", httpContext);
        	//webContainer.registerWelcomeFiles(new String[] {"index.html"}, false, httpContext);
        	webContainer.registerFilter(new WelcomeFilter(), new String[] {"/"}, null, new Hashtable<String, String>(), httpContext);
        	//webContainer.registerServlet("/", new WelcomePageServlet("index.html"), new Hashtable<String, String>(), httpContext);

        	serverStarted = true;
    	} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NamespaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }

    private synchronized void stopServer() {
    	webContainer.unregister("/api");
    	webContainer.unregister("/");

    	serverStarted = false;
    }

    private synchronized void restartServer() {
    	stopServer();
    	startServer();
    }
 }
